local LuaTable = require "LuaTable";

print("input map name to convert");
local mapname = io.stdin:read();

local map = require(mapname);

local converted_map = {};
converted_map.width = map.width;
converted_map.height = map.height;

converted_map.mapdata = {};

local tileset_objects;
local layer_monsters;
local layer_special;
local layer_items;
local layer_tiles;
for i = 1, #map.tilesets do
  if(map.tilesets[i].name == "objects") then
    tileset_objects = map.tilesets[i];
    break;
  end
end
for i = 1, #map.layers do
  if(map.layers[i].name == "Monsters") then
    layer_monsters = map.layers[i];
  end
  if(map.layers[i].name == "Items") then
    layer_items = map.layers[i];
  end
  if(map.layers[i].name == "Special") then
    layer_special = map.layers[i];
  end
  if(map.layers[i].name == "Tiles") then
    layer_tiles = map.layers[i];
  end
end

local objects = {};

for i = 1, #tileset_objects.tiles do
  objects[i+tileset_objects.firstgid-1] = tileset_objects.tiles[i].type;
end

for u = 0, map.height - 1 do
  for v = 0, map.width - 1 do
    local tile = {};
    local data = u * map.width + v;
    if(layer_tiles.data[data + 1] == 1) then
      tile.solid = 1;
    else
      tile.solid = 0;
    end
    if(layer_monsters.data[data + 1] > 0) then
      tile.monster = objects[layer_monsters.data[data + 1]];
    end
    if(layer_items.data[data + 1] > 0) then
      tile.item = objects[layer_items.data[data + 1]];
    end
    if(layer_special.data[data + 1] > 0) then
      if(objects[layer_special.data[data + 1]] == "player_start") then
        converted_map.player_start_x = v * 32;
        converted_map.player_start_y = u * 32;
      end
      tile.special = objects[layer_special.data[data + 1]];
    end
    converted_map.mapdata[data + 1] = tile;
  end
end

local savedata = LuaTable.encode(converted_map);
print(savedata);

file = io.open(mapname.."_conv.lua", "w");
file:write(savedata);

--print(map.version);
print("done PRESS ENTER TO EXIT");
io.stdin:read();
