local hud = {};
local player = {};
local monster = require "monster";
local battle = require "battle";

local win_h = love.graphics.getHeight();
local win_w = love.graphics.getWidth();

local selected_mon;
local in_battle = false;
local font = love.graphics.newFont("DejaVuSansBold.ttf", 18);
local ptext_color = {255, 255, 255};
local etext_color = {255, 255, 255};

function hud.init(p)
    player = p;
    love.graphics.setFont(font);
end

function hud.draw()
  love.graphics.setColor(ptext_color);
  love.graphics.print("PLAYER", 32, win_h - 80)
  love.graphics.print("HP: "..player.stats.hp, 32, win_h - 64);
  love.graphics.print("ATK: "..player.stats.atk, 32, win_h - 48);
  love.graphics.print("DEF: "..player.stats.def, 32, win_h - 32);
  
  if selected_mon then
    local name = string.upper(selected_mon);
    local mon;
    if in_battle then
      mon = battle.get_enemy();
    else
      mon = monster.types[selected_mon];
    end
    love.graphics.setColor(etext_color);
    love.graphics.printf(name, win_w - 232, win_h - 80, 200, 'right')
    love.graphics.printf("HP: "..mon.hp, win_w - 132, win_h - 64, 100, 'right');
    love.graphics.printf("ATK: "..mon.atk, win_w - 132, win_h - 48, 100, 'right');
    love.graphics.printf("DEF: "..mon.def, win_w - 132, win_h - 32, 100, 'right');
  end
  love.graphics.setColor(255, 255, 255);
end

function hud.change_color(b)
    if battle.turn() == 1 then
      ptext_color = {255, 255, 255};
      etext_color = {255, 0, 0};
    end
    if battle.turn() == 0 then
      ptext_color = {255, 0, 0};
      etext_color = {255, 255, 255};
    end
    if (not b) then
      ptext_color = {255, 255, 255};
      etext_color = {255, 255, 255};
    end
end

function hud.set_mon(type, battle)
  selected_mon = type;
  print(selected_mon);
  if battle ~= nil then
    in_battle = battle;
  end
end

return hud;