local map = require "map";
local player = require "player";
local battle = require "battle";
local hud = require "hud";

--love.filesystem.mount(love.filesystem.getSourceBaseDirectory(), "");
--local setting = love.filesystem.load("setting.lua")();

local cr_x;
local cr_y;
local tl_x;
local tl_y;
local win_h;
local win_w;
local images;
local quads;
local tile;
local time;

local move = player.move;
local keys = {escape = {love.event.quit},
              kp8 = {move, "up"},
              kp6 = {move, "right"},
              kp4 = {move, "left"},
              kp2 = {move, "down"}};

function love.load()
--  file = love.filesystem.newFile("file.txt");
--  file:open('w');
--  file:write("");
--  file:close();
  
  time = 0;

  cr_x = 0;
  cr_y = 0;
  tl_x = 0;
  tl_y = 0;

  win_h = love.graphics.getHeight();
  win_w = love.graphics.getWidth();

  images = {tiles = 0,
            player = 0,
            rat = 0,
            potion = 0,
            power = 0,
            titan = 0,
            raven = 0,
            orb_spider = 0,
            portal = 0};
          
  for i, v in pairs(images) do
    images[i] = love.graphics.newImage(i..".png");
  end
  
  local tiles_w = images["tiles"]:getWidth();
  local tiles_h = images["tiles"]:getHeight();
  quads = {love.graphics.newQuad(0, 0, 32, 32, tiles_w, tiles_h),
           love.graphics.newQuad(32, 0, 32, 32, tiles_w, tiles_h)};

  map.load_map("map01_conv.lua");
  imgd_map = nil;

  local px, py = map.get_player_pos()
  player.init(px, py, images["player"])
  -- file:open('a');
  -- for i,v in ipairs(mapdata) do
  --   file:write(v);
  -- end
  -- file:close();
  tile = 0;
end

function love.draw()
  map.draw_map(images, quads);
  player.draw();

  love.graphics.setColor(0, 255, 0);
  love.graphics.line(cr_x, 0, cr_x, win_h);
  love.graphics.line(0, cr_y, win_w, cr_y);
  love.graphics.print(cr_x, 0, 0);
  love.graphics.print(cr_y, 32, 0);
  love.graphics.setColor(255, 255, 255);
  love.graphics.print(tl_x, 0, 20);
  love.graphics.print(tl_y, 32, 20);
  love.graphics.print(tile, 64, 20);

  hud.draw();
end

function love.update(dt)
    player.update(dt);
end

function love.keypressed(key)
  if keys[key] then
    local action = keys[key][1];
    if(action) then
      local param = keys[key][2];
      if(param) then
        action(param);
        print("param: "..param);
      else
        action();
      end
    end
  end
end

function love.mousepressed(x, y, button, istouch)
  if(button == 2) then
    --cr_x = x;
    --cr_y = y;
    tl_x = math.floor(x / 32)*32;
    tl_y = math.floor(y / 32)*32;
    --cr_x = tl_x;
    --cr_y = tl_y;
    tile = map.get_tile(tl_x, tl_y);
    if tile.monster then
        hud.set_mon(tile.monster);
        print(tile.monster);
    else
        hud.set_mon(nil);
    end
  end
end
