local map = {};

local mapdata = {};
local map_w = 0;
local map_h = 0;
local player_start_x = 0;
local player_start_y = 0;

local colors = {wall = {0, 0, 0},
                player_start = {0, 255, 0},
                rat = {255, 0, 0}};

function map.get_player_pos()
  return player_start_x, player_start_y;
end

function map.get_size()
  return map_w, map_h;
end

local function obj_player_start(x, y)
  player_start_x = x * 32;
  player_start_y = y * 32;
  print("player start x and y: "..player_start_x.." "..player_start_y);
  --mapdata[#mapdata + 1] = 0;
  return nil;
end

local function obj_monster(x, y, type)
  -- local new_ind = #monsters + 1;
  -- local new_mon = {type = type, x = x * 32, y = y * 32};
  -- monsters[new_ind] = new_mon;
  --print("rat x and y: "..map.player_start_x.." "..map.player_start_y);
--  mapdata[#mapdata + 1] = 0;
  return {monster = type}
end

local object_types = {wall = 1,
                      player_start = obj_player_start,
                      rat = obj_monster};

local function getcolor(r, g, b)
  for c, v in pairs(colors) do
    if(r == v[1] and g == v[2] and b == v[3]) then
      return c;
    end
  end
end

local function set_tile(solid, contents)
  local tile = {};
  tile.solid = solid;
  if(contents and type(contents) == "table") then
    for i, v in pairs(contents) do
      tile[i] = v;
    end
  end
  return tile;
end

-- function map.load_map(dmap)
--   mapdata = {};
--   monsters = {};
--   local w = dmap:getWidth();
--   local h = dmap:getHeight();
--   for u = 0, h - 1 do
--     for v = 0, w - 1 do
--       local r, g, b = dmap:getPixel(v, u);
--       local type = getcolor(r, g, b);
--       local tile;
--       local tile_contents;
--       if(type == "wall") then
--         tile = set_tile(1);
--       else
--         if(object_types[type]) then
--           tile_contents = object_types[type](v, u, type);
--         end
--         tile = set_tile(0, tile_contents);
--       end
--       mapdata[#mapdata + 1] = tile;
--     end
--   end
--   map_w = w;
--   map_h = h;
-- end

function map.load_map(filename)
  local loadmap = love.filesystem.load(filename)();
  mapdata = {};

  map_h = loadmap.height;
  map_w = loadmap.width;
  
  for u = 0, map_h - 1 do
    for v = 0, map_w - 1 do
      local data = u * map_w + v;
      local tile = {};
      tile.solid = loadmap.mapdata[data + 1].solid;
      tile.item = loadmap.mapdata[data + 1].item;
      tile.monster = loadmap.mapdata[data + 1].monster;
      tile.special = loadmap.mapdata[data + 1].special;
      mapdata[data + 1] = tile;
    end
  end
  
  player_start_x = loadmap.player_start_x;
  player_start_y = loadmap.player_start_y;
  --print(mapdata[175].solid);
  --if(mapdata) then print("mapdata is"); end
end



function map.draw_map(images, quads)
  for u = 0, map_h - 1 do
    for v = 0, map_w - 1 do
      local x = v * 32;
      local y = u * 32;
      local tile = map.get_tile(x, y);
      if(tile.solid == 1) then
        love.graphics.draw(images["tiles"], quads[1], x, y);
      else
        love.graphics.draw(images["tiles"], quads[2], x, y);
      end
      if(tile.monster) then
        love.graphics.draw(images[tile.monster], x, y);
      end
      if(tile.item) then
        love.graphics.draw(images[tile.item], x, y);
      end
      if(tile.special) then
        if(tile.special ~= "player_start") then
          love.graphics.draw(images[tile.special], x, y);
        end
      end
    end
  end
end

function map.get_tile(x, y)
  local data_v = x / 32;
  local data_u = y / 32;
  local data = data_u * map_w + data_v;
  local tile = mapdata[data + 1];
  --print("tile x: "..x.."tile y: "..y.."tile solid: "..tile.solid)
  return tile;
end

function map.remove_object(x, y, what)
  local tile = map.get_tile(x, y);
  if(tile[what]) then
    tile[what] = nil;
  end
end

return map;
