local player = {};
local map = require "map";
local battle = require "battle";
local item = require "item";
local hud = require "hud";

player.x = 0;
player.y = 0;
player.stats = {hp = 500, atk = 10, def = 10};

local things = {"wall"};
local img;
local can_move = true;
local in_battle = false;
local btime = 0;
local dead = false;
local bint = 0.5;

local function do_move(x, y)
  local new_x = player.x + x;
  local new_y = player.y + y;
  local tile;
  local battle_result;
  local map_w, map_h = map.get_size();
  local move = false;
  print(new_x.." "..new_y);
  if(new_x >= 0 and new_y >= 0 and new_x < map_w * 32 and new_y < map_h * 32) then
    tile = map.get_tile(new_x, new_y);
    if(tile.solid ~= 1) then
      --start a battle if there's a monster
      if(tile.monster) then
        print("theres a monster "..tile.monster);
--        battle_result = battle.start(player.stats, tile.monster);
--        if(battle_result.outcome == 1) then
--          player.stats.hp = player.stats.hp - battle_result.hploss;
--          map.remove_object(new_x, new_y, "monster");
--        elseif(battle_result.outcome == 2) then
--          player.stats.hp = 0;
--        end
        battle.start(player.stats, tile.monster, new_x, new_y);
        hud.set_mon(tile.monster, true);
        can_move = false;
        in_battle = true;
      else
        move = true;
      end
    end
  else
    print("ran into map boundary");
  end
  if(move) then
    player.x = new_x;
    player.y = new_y;
  end

  if(tile.item) then
    print("got item "..tile.item);
    for i, v in pairs(player.stats) do
      player.stats[i] = player.stats[i] + item.types[tile.item][i];
      move = true;
    end
    map.remove_object(new_x, new_y, "item");
  end
  if(tile.special and tile.special == "portal") then
    print("u win!!!!!!");
  end
end

function player.move(dir)
  print("move");
  local move_x = 0;
  local move_y = 0;
  if(dir == "up") then
    move_y = -32;
  end
  if(dir == "down") then
    move_y = 32;
  end
  if(dir == "left") then
    move_x = -32;
  end
  if(dir == "right") then
    move_x = 32;
  end
  if can_move then
    do_move(move_x, move_y);
  end
  if dead then
      print("ur ded lol");
  end
end

function player.draw()
    love.graphics.draw(img, player.x, player.y)
end

function player.update(dt)
  --print("player update");
  if(player.stats.hp > 0) then
    if (in_battle) then
      btime = btime + dt;
      while (btime >= bint) do
        btime = btime - bint;
        if (battle.step() == 1) then
          local en_x, en_y = battle.enemy_pos();
          in_battle = false;
          can_move = true;
          map.remove_object(en_x, en_y, "monster");
          hud.set_mon(nil, false);
          hud.change_color(false);
        else
          hud.change_color(true);
        end
      end
    end
  else
    in_battle = false;
    print("ur ded lol");
  end
end

function player.init(x, y, image, set)
    player.x = x;
    player.y = y;
    img = image;
    hud.init(player);
    if set then
      if set.battle_speed then
        bint = set.battle_speed
      end
    end
end

return player;
